/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: vmspacePointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the vmspacePointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=vmspace.class)
public class vmspacePointer extends StructurePointer {

	// NULL
	public static final vmspacePointer NULL = new vmspacePointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected vmspacePointer(long address) {
		super(address);
	}

	public static vmspacePointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static vmspacePointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static vmspacePointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new vmspacePointer(address);
	}

	public vmspacePointer add(long count) {
		return vmspacePointer.cast(address + (vmspace.SIZEOF * count));
	}

	public vmspacePointer add(Scalar count) {
		return add(count.longValue());
	}

	public vmspacePointer addOffset(long offset) {
		return vmspacePointer.cast(address + offset);
	}

	public vmspacePointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public vmspacePointer sub(long count) {
		return vmspacePointer.cast(address - (vmspace.SIZEOF * count));
	}

	public vmspacePointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public vmspacePointer subOffset(long offset) {
		return vmspacePointer.cast(address - offset);
	}

	public vmspacePointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public vmspacePointer untag(long mask) {
		return vmspacePointer.cast(address & ~mask);
	}

	public vmspacePointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return vmspace.SIZEOF;
	}

	// Implementation methods

	// I32 dummy
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_dummyOffset_", declaredType="I32")
	public IDATA dummy() throws CorruptDataException {
		return new I32(getIntAtOffset(vmspace._dummyOffset_));
	}

	// I32 dummy
	public IDATAPointer dummyEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(vmspace._dummyOffset_));
	}

	// caddr_t dummy2
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_dummy2Offset_", declaredType="caddr_t")
	public U8Pointer dummy2() throws CorruptDataException {
		return U8Pointer.cast(getPointerAtOffset(vmspace._dummy2Offset_));
	}

	// caddr_t dummy2
	public PointerPointer dummy2EA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(vmspace._dummy2Offset_));
	}

	// I32[] dummy3
	public IDATAPointer dummy3EA() throws CorruptDataException {
		return I32Pointer.cast(nonNullFieldEA(vmspace._dummy3Offset_));
	}

	// caddr_t[] dummy4
	public PointerPointer dummy4EA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(vmspace._dummy4Offset_));
	}

}
